/*
rndpwr.c - random number generator
    generates random number with normal distribution
    for powers of 2
    from 0 to (2^n) - 1
    where 1 <= n <= 32
Version 1.0.0
Copyright (C) 2003-2004 dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place - Suite 330
    Boston, MA  02111-1307, USA.
*/

/*
Usage:
        unsigned int i;
        i = rndpwr(int bits, unsigned char *rndSeed);
*/

/*
The inner loop starting with the label again:
is a copy of the function rnd().
*/

/* offset to high order byte of seed */
#define HIGHOFST 15

unsigned int rndpwr(int bits,unsigned char *rndSeed)
    {
    unsigned int rslt;
    int dbl[8];
   _asm push ebx
   _asm push ecx
   _asm push edx
   _asm push esi
   _asm push edi
   _asm mov  ecx,8[ebp]
   _asm cmp  ecx,32
   _asm ja   err
   _asm or   ecx,ecx
   _asm jnz  setup
   _asm err: xor  eax,eax
   _asm mov  [rslt],eax
   _asm jmp  quit
   _asm setup: xor edx,edx
   _asm again: mov esi,12[ebp]
   _asm lea edi,dbl
   _asm clc
   _asm mov eax,[esi]
   _asm shl eax,1
   _asm mov [edi],eax
   _asm mov eax,[esi+4]
   _asm rcl eax,1
   _asm mov [edi+4],eax
   _asm mov eax,[esi+8]
   _asm rcl eax,1
   _asm mov [edi+8],eax
   _asm mov eax,[esi+12]
   _asm rcl eax,1
   _asm mov [edi+12],eax
   _asm mov esi,rndSeed
   _asm mov edi,esi
   _asm add edi,8
   _asm clc
   _asm mov eax,[edi]
   _asm mov ebx,[esi]
   _asm add eax,ebx
   _asm mov [edi],eax
   _asm mov eax,[edi+4]
   _asm mov ebx,[esi+4]
   _asm adc eax,ebx
   _asm mov [edi+4],eax
   _asm lea esi,dbl
   _asm mov edi,rndSeed
   _asm clc
   _asm mov eax,[edi]
   _asm mov ebx,[esi]
   _asm add eax,ebx
   _asm mov [edi],eax
   _asm mov eax,[edi+4]
   _asm mov ebx,[esi+4]
   _asm adc eax,ebx
   _asm mov [edi+4],eax
   _asm mov eax,[edi+8]
   _asm mov ebx,[esi+8]
   _asm adc eax,ebx
   _asm mov [edi+8],eax
   _asm mov eax,[edi+12]
   _asm mov ebx,[esi+12]
   _asm adc eax,ebx
   _asm mov [edi+12],eax
   _asm shl eax,31  ; put high bit in carry
   _asm rcl edx,1   ; (edx << 1) | carry
   _asm loop again
   _asm mov  [rslt],edx
   _asm quit: pop edi
   _asm pop  esi
   _asm pop  edx
   _asm pop  ecx
   _asm pop  ebx
    return(rslt);
    } /* rndpwr */
